<?php


class Inbox extends AppModel
{
    public $useTable = 'inbox';

    public $belongsTo = array(
        'Sender' => array(
            'className' => 'User',
            'foreignKey' => 'sender_id',


        ),

        'Receiver' => array(
            'className' => 'User',
            'foreignKey' => 'receiver_id',


        ),
    );

    public function getDetails($id)
    {

        return $this->find('first', array(
            'conditions' => array('Inbox.id' => $id)
        ));

    }

  public function ifInboxExist($sender_id,$receiver_id)
    {

        return $this->find('first', array(
            'conditions' => array(
                'OR' =>
                    array(
                        array('AND' => array(
                            array('Inbox.sender_id' => $sender_id),
                            array('Inbox.receiver_id' => $receiver_id),

                        )),
                        array('AND' => array(
                            array('Inbox.sender_id' => $receiver_id),
                            array('Inbox.receiver_id' => $sender_id),

                        )),
                    )),
            'recursive' => -1


        ));


    }

    public function getInbox($user_id)
    {
        $this->Behaviors->attach('Containable');
        return $this->find('all', array(
            'conditions' => array(

                "OR" => array (
                    "Inbox.sender_id" => $user_id,
                    "Inbox.receiver_id" => $user_id,

                ),

            ),
            'contain' => array(
                'Sender.UserImage','Receiver.UserImage'
            )

        ));

    }

}

?>