<?php


class LikeUser extends AppModel
{
    public $useTable = 'like_user';


    public $belongsTo = array(
        'User' => array(
            'className' => 'User',
            'foreignKey' => 'user_id',
            'type' => 'INNER'


        ),

        'OtherUser' => array(
            'className' => 'User',
            'foreignKey' => 'other_user_id',
            'type' => 'INNER'


        ),
    );

    public function getDetails($id)
    {

        return $this->find('first', array(
            'conditions' => array('LikeUser.id' => $id)
        ));

    }

    public function IfUserHasSwipedLiked($user_id,$other_user_id)
    {

        return $this->find('first', array(
            'conditions' => array(
                'LikeUser.user_id' => $user_id,
                'LikeUser.other_user_id' => $other_user_id,
                'LikeUser.like' => 1,


                )
        ));

    }

    public function IfUserSwiped($user_id,$other_user_id)
    {

        return $this->find('first', array(
            'conditions' => array(
                'LikeUser.user_id' => $user_id,
                'LikeUser.other_user_id' => $other_user_id,



            )
        ));

    }

    public function IfUserHasSwipedSuperLiked($user_id,$other_user_id)
    {

        return $this->find('first', array(
            'conditions' => array(
                'LikeUser.user_id' => $user_id,
                'LikeUser.other_user_id' => $other_user_id,
                'LikeUser.super_like' => 1,


            )
        ));

    }

    public function getUserLikedAndUnlikedProfiles($user_id,$like)
    {

        return $this->find('all', array(
            'conditions' => array(
                'LikeUser.user_id' => $user_id,

                'LikeUser.like' => $like,


            )
        ));

    }


    public function getThoseUsersWhoLikedThisUser($user_id)
    {
        $this->Behaviors->attach('Containable');

        return $this->find('all', array(
            'conditions' => array(

                'OR' => array(
                    array('LikeUser.like' => 1,),
                    array('LikeUser.super_like' => 1,),
                ),
                'LikeUser.other_user_id' => $user_id,





            ),
            'contain' => array(
                'User.UserImage','OtherUser.UserImage','User.School','User.UserPassion.Passion','User.UserSexualOrientation.SexualOrientation','OtherUser.School','OtherUser.UserPassion.Passion','OtherUser.UserSexualOrientation.SexualOrientation'
            ),
            'group' => '`LikeUser`.`user_id`',
        ));

    }

    public function getCountThoseUsersWhoLikedThisUser($user_id)
    {
        //$this->Behaviors->attach('Containable');

        return $this->find('count', array(
            'conditions' => array(

                'OR' => array(
                    array('LikeUser.like' => 1,),
                    array('LikeUser.super_like' => 1,),
                ),
                'LikeUser.other_user_id' => $user_id,




            ),

        ));

    }

    public function getSingleUserWhoLikedThisUser($user_id)
    {
        $this->Behaviors->attach('Containable');

        return $this->find('first', array(
            'conditions' => array(

                'OR' => array(
                    array('LikeUser.like' => 1,),
                    array('LikeUser.super_like' => 1,),
                ),
                'LikeUser.other_user_id' => $user_id,




            ),
            'contain' => array(
                'User.UserImage','OtherUser.UserImage'
            )

        ));

    }

    public function IfUserHasSwiped($user_id,$other_user_id)
    {

        return $this->find('first', array(
            'conditions' => array(
                'LikeUser.user_id' => $user_id,
                'LikeUser.other_user_id' => $other_user_id,



            )
        ));

    }

    public function getUserSwipedInADay($user_id,$date)
    {

        return $this->find('count', array(
            'conditions' => array(
            'LikeUser.user_id' => $user_id,

            'DATE(LikeUser.created)' => $date,
            )
        ));

    }

    public function getUserSuperLikeSwipedInADay($user_id,$date)
    {

        return $this->find('count', array(
            'conditions' => array(
            'LikeUser.user_id' => $user_id,
            'LikeUser.super_like' => 1,

            'DATE(LikeUser.created)' => $date,
            )
        ));

    }





}

?>